var toSmileParam = function(a) {
    if(a){
        var r20 = /%20/g, s = [], add = function(key, value) {
            // If value is a function, invoke it and return its value
            value = jQuery.isFunction(value) ? value() : value;
            s[s.length] = encodeURIComponent(key) + "=" + encodeURIComponent(value);
        };

        // If an array was passed in, assume that it is an array of form elements.
        if(jQuery.isArray(a) || (a.jquery && !jQuery.isPlainObject(a) )) {
            // Serialize the form elements
            jQuery.each(a, function() {
                add(this.name, this.value);
            });
        } else {
            for(var prefix in a) {
                buildParams2(prefix, a[prefix], add);
            }
        }

        // Return the resulting serialization
        return s.join("&").replace(r20, "+");
    } else {
      return ""
    }
}

var buildParams2 = function(prefix, obj, add) {
    if(jQuery.isArray(obj) && obj.length) {
        // Serialize array item.
        jQuery.each(obj, function(i, v) {
            buildParams2(prefix + "[" + i + "]", v, add);
        });
    } else if( typeof obj === "object") {
        for(var name in obj) {
            buildParams2(prefix + "." + name, obj[name], add);
        }

    } else {
        // Serialize scalar item.
        add(prefix, obj);
    }
}

